### Index

* [Ada](#ada)
* [Android](#android)
* [Bash](#bash)
* [C](#c)
* [C#](#c-sharp)
* [C++](#c-1)
* [Clojure](#clojure)
* [Cloud Computing](#cloud-computing)
* [CoffeeScript](#coffeescript)
* [Dart](#dart)
* [Erlang](#erlang)
* [Git](#git)
* [GLSL](#glsl)
* [Go](#go)
* [Haskell](#haskell)
* [HTML / CSS](#html--css)
  * [Bootstrap](#bootstrap)
* [Java](#java)
* [JavaScript](#javascript)
  * [Angular.js](#angularjs)
  * [jQuery](#jquery)
  * [React](#react)
* [Kotlin](#kotlin)
* [Language Agnostic](#language-agnostic)
  * [Operating Systems](#operating-systems)
* [LaTeX](#latex)
* [Lisp](#lisp)
* [MATLAB](#matlab)
* [Node](#node)
* [NoSQL](#nosql)
* [Objective-C](#objective-c)
* [Ocaml](#ocaml)
* [PHP](#php)
* [Python](#python)
* [Ruby](#ruby)
* [Rust](#rust)
* [Scala](#scala)
* [SQL](#sql)
* [Vim](#vim)


### Ada

* [Introduction to Ada](https://learn.adacore.com/courses/intro-to-ada/index.html)


### Android

* [Javatpoint Android Tutorial](https://www.javatpoint.com/android-tutorial)


### Bash

* [Help messages will explain everything](https://explainshell.com)
* [Learn Shell Programming](http://www.learnshell.org)


### C

* [Learn C](http://www.learn-c.org)


### C Sharp

* [C# Tutorial](https://www.w3schools.com/cs) - W3Schools
* [Codeasy](https://codeasy.net/course/csharp_elementary)
* [Learn C#](http://www.learncs.org)
* [Learn C#](https://www.codecademy.com/learn/learn-c-sharp) - Codecademy


### C++

* [C++ Tutorial](https://www.w3schools.com/cpp) - W3Schools
* [CppKoans](https://github.com/torbjoernk/CppKoans)


### Clojure

* [4Clojure - Koans](http://www.4clojure.com)
* [Clojure Koans](http://clojurekoans.com)
* [ClojureScript Koans](http://clojurescriptkoans.com)
* [Try Clojure](http://www.tryclj.com)


### Cloud Computing 

* [AWS API Gateway](https://run.qwiklabs.com/focuses/269?catalog_rank=%7B%22rank%22%3A3%2C%22num_filters%22%3A1%2C%22has_search%22%3Atrue%7D&parent=catalog&search_id=3605949) - *registration required*
* [AWS Identity and Access Management (IAM)](https://run.qwiklabs.com/focuses/7782?catalog_rank=%7B%22rank%22%3A6%2C%22num_filters%22%3A1%2C%22has_search%22%3Atrue%7D&parent=catalog&search_id=3605942) - *registration required*
* [AWS Lambda](https://run.qwiklabs.com/focuses/6431?catalog_rank=%7B%22rank%22%3A2%2C%22num_filters%22%3A1%2C%22has_search%22%3Atrue%7D&parent=catalog&search_id=3605949) - *registration required*
* [AWS Simple Storage Service (S3)](https://run.qwiklabs.com/focuses/7860?catalog_rank=%7B%22rank%22%3A3%2C%22num_filters%22%3A0%2C%22has_search%22%3Atrue%7D&parent=catalog&search_id=3597563) - *registration required*
* [Google Cloud Platform](https://cloud.google.com/training/free-labs/)


### CoffeeScript

* [Coffeescript Style Guide](https://github.com/polarmobile/coffeescript-style-guide/blob/master/README.md)
* [Smooth CoffeeScript, Interactive Edition](http://autotelicum.github.io/Smooth-CoffeeScript/interactive/interactive-coffeescript.html)


### Dart

* [Dart Official Codelabs](https://dart.dev/codelabs)


### Erlang

* [Try Erlang](http://www.tryerlang.org)


### Git

* [git-game](https://github.com/git-game/git-game)
* [git-game-v2](https://github.com/git-game/git-game-v2)
* [Githug](https://github.com/Gazler/githug) (Tutorial in shell)
* [Learn Git Branching](https://learngitbranching.js.org)
* [Learn Git with Bitbucket Cloud](https://www.atlassian.com/git/tutorials/learn-git-with-bitbucket-cloud)
* [Try Git](http://try.github.io)


### GLSL

* [The Book of Shaders](https://thebookofshaders.com)


### Go

* [Go Koans](https://github.com/cdarwin/go-koans)
* [The Go Tutorial](http://tour.golang.org)


### Haskell

* [Try Haskell!](http://tryhaskell.org)


### HTML / CSS

* [CSS Diner](http://flukeout.github.io)
* [CSS Tutorial](https://www.w3schools.com/css/) - W3Schools
* [Flexbox Defense](http://flexboxdefense.com)
* [Flexbox Froggy](http://flexboxfroggy.com)
* [FreeCodeCamp: Responsive Web Design Course](https://www.freecodecamp.org/learn/responsive-web-design/basic-html-and-html5/)
* [Grid Garden](https://cssgridgarden.com)
* [HTML Tutorial](https://www.w3schools.com/html/) - W3Schools
* [Learn by doing beginner projects](https://dash.generalassemb.ly)
* [Learn HTML & CSS interactively](https://www.codecademy.com/learn/web)
* [Prototyping a professional website](https://www.codecademy.com/learn/make-a-website)


#### Bootstrap

* [Front End Libraries: Bootstrap](https://www.freecodecamp.org/learn/front-end-libraries/bootstrap)


### Java

* [CodingBat code practice](http://codingbat.com/java)
* [Java at Codecademy](https://www.codecademy.com/courses/learn-java)
* [Java Tutorial](https://www.w3schools.com/java) - W3Schools 
* [Learn Java](http://www.learnjavaonline.org)
* [Learneroo Java tutorial](https://www.learneroo.com/modules/11)


### JavaScript

* [ABC of JavaScript : An Interactive JavaScript Tutorial](http://www.openjs.com/tutorials/basic_tutorial/)
* [Codecademy jquery track](https://www.codecademy.com/learn/jquery)
* [ES6 Interactive Guide](http://stack.formidable.com/es6-interactive-guide/#/)
* [Functional Programming in Javascript](https://github.com/ReactiveX/learnrx)
* [JavaScript Algorithms and Data Structures Certification](https://www.freecodecamp.org/learn/javascript-algorithms-and-data-structures/basic-javascript)
* [Javascript interactive tutorial on CodeCademy](https://www.codecademy.com/learn/javascript)
* [JavaScript interactive tutorial on CoderMania](http://www.codermania.com/javascript/lesson/1a/hello-world)
* [JavaScript Tutorial](https://www.w3schools.com/js) - W3Schools
* [Javascripting](https://github.com/sethvincent/javascripting)
* [Learn JavaScript](http://www.learn-js.org)
* [Learn knockout.js](http://learn.knockoutjs.com)
* [Learn to Code for Free – Grasshopper](https://grasshopper.app)
* [Learning Advanced JavaScript](http://ejohn.org/apps/learn/)
* [Try jQuery](http://try.jquery.com)


#### Angular.js

* [Angular Basics](http://www.angularjsbook.com)
* [Angular Tutorial](https://www.w3schools.com/angular/) - W3Schools
* [AngularJS - Step by Logical Step](http://nicholasjohnson.com/angular-book/)
* [egghead.io: Learn AngularJS with Tutorial Videos & Training](https://egghead.io)
* [Learn AngularJS with free interactive lessons](http://www.learn-angular.org)


#### jQuery

* [Front End Libraries: jQuery](https://www.freecodecamp.org/learn/front-end-libraries/jquery)


#### React

* [Front End Libraries: React](https://www.freecodecamp.org/learn/front-end-libraries/react)
* [React Tutorial](https://react-tutorial.app)


### Kotlin

* [Kotlin tutorial](https://kotlinlang.org/docs/tutorials/)


### Language Agnostic

* [CodeCombat](http://codecombat.com) - Python, JavaScript, CoffeeScript, Clojure, Lua, Io
* [Codility](https://codility.com/programmers/)
* [Introduction to the Coding Interview Prep Algorithms](https://www.freecodecamp.org/learn/coding-interview-prep/algorithms) (freeCodeCamp)
* [Python Tutor](http://pythontutor.com) - Python, Java, JavaScript, TypeScript, Ruby, C, C++
* [The Fullstack Tutorial for GraphQL](https://www.howtographql.com)


#### Operating systems

* [Learning operating system development using Linux kernel and Raspberry Pi](https://github.com/s-matyukevich/raspberry-pi-os) - Sergey Matyukevich (:construction: *in process*)


### LaTeX

* [Learn LaTeX in 30 minutes](https://www.overleaf.com/learn/latex/Learn_LaTeX_in_30_minutes)


### Lisp

* [Lisp Koans](https://github.com/google/lisp-koans)


### MATLAB

* [Interactive Tutorials for MATLAB, Simulink, Signal Processing, Controls, and Computational Mathematics](http://www.mathworks.com/tutorials)


### Node

* [Node School](http://nodeschool.io)
* [Node.js Tutorial](https://www.w3schools.com/nodejs) - W3Schools


### NoSQL

* [MongoDB Koans](https://github.com/chicagoruby/MongoDB_Koans)
* [Try Redis](http://try.redis.io)


### Objective-C

* [Try Objective-C](http://tryobjectivec.codeschool.com)


### Ocaml

* [Try Ocaml](http://try.ocamlpro.com)


### PHP

* [CodeCademy PHP](https://www.codecademy.com/learn/php)
* [Learn PHP](http://www.learn-php.org)
* [PHP tutorial](https://www.w3schools.com/php) - W3Schools


### Python

* [Codecademy Python course](https://www.codecademy.com/learn/python)
* [How to Think Like a Computer Scientist: Learning with Python, Interactive Edition](http://interactivepython.org/courselib/static/thinkcspy/index.html)
* [Learn Python](http://www.learnpython.org)
* [Learn Python Step by Step](http://www.techbeamers.com/python-tutorial-step-by-step)
* [Python for Everybody - Interactive](https://runestone.academy/runestone/books/published/py4e-int/index.html) - Barbara Ericson
* [Python Koans](https://github.com/gregmalcolm/python_koans)
* [Python Pandas Tutorial: A Complete Introduction for Beginners](https://www.learndatasci.com/tutorials/python-pandas-tutorial-complete-introduction-for-beginners/) - George McIntire, Brendan Martin, Lauren Washington
* [Python Tutorial](https://www.w3schools.com/python) - W3Schools


### Ruby

* [CodeCademy Ruby](https://www.codecademy.com/learn/ruby)
* [Ruby Koans](http://www.rubykoans.com)
* [The Odin Project](http://www.theodinproject.com)
* [Try Ruby](http://tryruby.org)


### Rust

* [Rustlings](https://github.com/rust-lang/rustlings)


### Scala

* [A Tour of Scala - an interactive scala tutorial](https://scalatutorials.com/tour/)
* [Scala Exercises](https://www.scala-exercises.org)


### Selenium

* [Selenium Tutorial - Web Automation](http://www.techbeamers.com/selenium-webdriver-tutorial)


### SQL

* [Intro to SQL: Querying and managing data](https://www.khanacademy.org/computing/computer-programming/sql) - Khan Academy
* [SQL at Codecademy](https://www.codecademy.com/courses/learn-sql)
* [SQL Tutorial](https://www.w3schools.com/sql) - W3Schools
* [SQLBolt](http://sqlbolt.com)


### Vim

* [Interactive Vim Tutorial](http://www.openvim.com/tutorial.html)
